Name: coreutils
Version: 5.2.1
Release: alt5

Summary: The GNU versions of common management utilities
License: GPL
Group: System/Base
Url: ftp://ftp.gnu.org/gnu/%name
Packager: Coreutils Development Team <coreutils@packages.altlinux.org>

Source: %url/%name-%version.tar.bz2

# sources from fileutils
Source11: color_ls.sh
Source12: color_ls.csh

# sources from sh-utils
Source20: exit.S
Source21: getuseruid.c
Source22: realpath.c
Source23: runas.c
Source24: runbg.c
Source25: usleep.c
Source26: runas.1
Source27: usleep.1

# ALT patches, candidates for upstream version
# and CVS backports.
Patch1: coreutils-5.2.1-up-date.patch
Patch2: coreutils-5.2.1-up-tests.patch
Patch3: coreutils-5.2.1-up-du.patch
Patch4: coreutils-5.2.1-up-stty-iutf8.patch
Patch5: coreutils-5.2.1-up-chown.patch
Patch6: coreutils-5.2.1-alt-readlink.patch

# patches from fileutils.
Patch11: fileutils-4.1.11-rh-owl-install-C.patch
Patch12: fileutils-4.1.11-rh-owl-ls_default_time_style.patch

# ALT specific.
Patch101: coreutils-4.5.7-alt-texinfo.patch
Patch102: coreutils-5.2.0-alt-mksock.patch
Patch103: coreutils-4.5.3-alt-dircolors.patch
Patch104: coreutils-5.2.0-alt-without-hostname-su-uptime.patch
Patch105: coreutils-5.2.0-alt-ls_dir_vdir.patch

# other.
Patch201: coreutils-5.2.0-owl-alt-fixes.patch
Patch202: coreutils-5.2.0-rh-install_strip.patch
Patch203: coreutils-5.2.0-rh-owl-alt-ls_dumbterm.patch
Patch204: coreutils-4.5.3-rh-langinfo.patch
Patch205: coreutils-5.1.3-rh-afs.patch
Patch206: coreutils-5.1.3-rh-allow_old_options.patch
Patch207: coreutils-5.2.0-rh-alt-ls-stat.patch
Patch208: coreutils-4.5.3-rh-man-date.patch

Provides: /bin/du /bin/install /bin/mkfifo /bin/readlink
Provides: /bin/cat /bin/cut /bin/head /bin/sort /bin/tail /bin/wc
Provides: %_bindir/mksock %_bindir/realpath

Provides: stat = %version, fileutils = %version, textutils = %version, sh-utils = %version
Obsoletes: stat, fileutils, textutils, sh-utils
Conflicts: man-pages < 0:1.52-alt2, initscripts < 0:5.49-ipl41mdk, rpm-build < 0:4.0.4-alt7
# due to /bin/kill
Conflicts: util-linux < 0:2.12-alt1
# due to /usr/bin/kill and %_man1dir/kill.1
Conflicts: procps < 0:2.0.10-alt4
# due to change in "readlink -f"
Conflicts: chrooted < 0:0.3.1-alt1
# due to buggy rpmdups/rpmrdups
Conflicts: rpm-utils < 0:0.7.6-alt1

Requires(post): %install_info
Requires(preun): %uninstall_info

BuildPreReq: texinfo >= 0:4.3

# Automatically added by buildreq on Tue Jun 03 2003
BuildRequires: libtinfo-devel

%description
These are the GNU core utilities.  This package is the union of
the GNU fileutils, sh-utils, and textutils packages.

These tools are the GNU versions of common useful and popular
file and text utilities which are used for:
+ file management
+ shell scripting
+ modifying text file

Most of these programs have significant advantages over their Unix
counterparts, such as greater speed, additional options, and fewer
arbitrary limits.

%prep
%setup -q

# ALT patches, candidates for upstream version
# and CVS backports.
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p1
%patch6 -p1
chmod u+x tests/readlink/*-*

# patches from fileutils.
%patch11 -p1
%patch12 -p1

# ALT specific.
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1

# other.
%patch201 -p1
%patch202 -p1
%patch203 -p1
%patch204 -p1
%patch205 -p1
%patch206 -p1
%patch207 -p1
%patch208 -p1

find -type f -name \*.orig -print -delete

# Get rid of hostname, su and uptime.
%__rm -fv {src,man}/{hostname,su,uptime}.*

# begin HACK
%__subst 's/dist_man_MANS/man_MANS/g' man/Makefile.am
# end HACK

# Fix docs: it should say /var/run/[uw]tmp not /etc/[uw]tmp
%__grep -Zl /etc/[uw]tmp doc/* man/* |
	xargs -r0 %__subst -p 's,/etc/utmp,/var/run/utmp,g;s,/etc/wtmp,/var/log/wtmp,g'

%__rm -f doc/*.info* man/*.1

%build
aclocal -I m4
autoheader
automake
autoconf

# hack to disable uptime build.
export gnulib_cv_have_boot_time=no

%configure --exec-prefix=/
%make_build

%{?!__buildreqs:%{?!_without_check:%{?!_disable_check:%make_build check}}}

# Build assembler version of true and false.
gcc -nostartfiles -nodefaultlibs -nostdlib "$RPM_SOURCE_DIR"/exit.S -DSTATUS=0 -o true
gcc -nostartfiles -nodefaultlibs -nostdlib "$RPM_SOURCE_DIR"/exit.S -DSTATUS=1 -o false

# Build additional utilities.
for n in getuseruid realpath runas runbg usleep; do
	gcc $RPM_OPT_FLAGS "$RPM_SOURCE_DIR/$n.c" -o $n
done

bzip2 -9fk ChangeLog NEWS THANKS

%install
%makeinstall
%__install -pD -m644 src/dircolors.hin "$RPM_BUILD_ROOT%_sysconfdir/DIR_COLORS"

pushd "$RPM_BUILD_ROOT"
	%__mkdir_p bin
	
#replace fileutils
        for n in \
	    chgrp chmod chown cp dd df du install link ln ls \
	    mkdir mkfifo mknod mv readlink rm rmdir sync touch unlink \
	; do
		%__mv "$RPM_BUILD_ROOT%_bindir/$n" "$RPM_BUILD_ROOT/bin/"
	done

	# dir and vdir now symlinks to ls.
	%__ln_s -nf ../../bin/ls "$RPM_BUILD_ROOT%_bindir/dir"
	%__ln_s -nf ../../bin/ls "$RPM_BUILD_ROOT%_bindir/vdir"

#replace textutils
	for n in cat cut head sort tail wc; do
		%__mv "$RPM_BUILD_ROOT%_bindir/$n" "$RPM_BUILD_ROOT/bin/"
		%__ln_s "../../bin/$n" "$RPM_BUILD_ROOT%_bindir/"
	done

#replace sh-utils
	for i in basename date echo false kill nice pwd sleep stty true uname; do
		%__mv .%_bindir/$i ./bin/
	done

	%__mkdir_p .%_sbindir
	%__mv .%_bindir/chroot .%_sbindir/

	%__ln_s -nf test .%_bindir/[

#compatibility symlinks
	for f in du install kill mkfifo; do
		%__ln_s ../../bin/$f .%_bindir/
	done

	%__mkdir_p .%_sysconfdir/profile.d
	%__install -p -m755 %SOURCE11 %SOURCE12 .%_sysconfdir/profile.d/
	%__ln_s ../../bin/install .%_bindir/ginstall
popd

# Install assembler versions of true and false.
%__install -p -m755 true false "$RPM_BUILD_ROOT/bin/"

# Install additional utilities and its manpages.
%__install -p -m755 getuseruid runas usleep $RPM_BUILD_ROOT/bin/
%__install -p -m755 realpath runbg $RPM_BUILD_ROOT%_bindir/
%__install -p -m644 $RPM_SOURCE_DIR/{runas,usleep}.1 $RPM_BUILD_ROOT%_man1dir/

%find_lang %name

%pre
# Remove info pages from fileutils, textutils and sh-utils.
for f in %_infodir/{fileutils,textutils,sh-utils}.info*; do
	[ -f "$f" ] || continue
	RPM_INSTALL_ARG1=0 %_sbindir/uninstall_info "$f" ||:
done

%post
%install_info %name.info

%preun
%uninstall_info %name.info

%files -f %name.lang
%config(noreplace) %_sysconfdir/DIR_COLORS
%config(noreplace) %_sysconfdir/profile.d/*
/bin/*
%_bindir/*
%_sbindir/*
%_mandir/man?/*
%_infodir/*.info*
%doc ChangeLog.bz2 NEWS.bz2 THANKS.bz2 AUTHORS README TODO

%changelog
* Thu Jun 03 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt5
- Fixed canonicalize_file_name behaviour.
- Changed default behaviour for chown/chgrp.

* Sun Apr 25 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt4
- Backported "stty -iutf8" option support.
  Requires quite fresh glibc-devel package at build time.

* Sun Apr 04 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt3
- readlink: implemented more canonicalize options.

* Wed Mar 31 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt2
- Assorted backports from cvs head.
- Package /bin/kill, %_bindir/kill and its manpage from coreutils.

* Sat Mar 13 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt1
- Updated to 5.2.1
- Merged upstream patches:
  eggert-chown-lsb
  alt-cloexec

* Tue Mar 02 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.0-alt2
- chown: applied patch from Paul Eggert, see
  http://mail.gnu.org/archive/html/bug-coreutils/2004-02/msg00125.html
- nohup: fixed nasty fd leak.

* Mon Feb 23 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.0-alt1
- Updated to 5.2.0, reviewed patches.
- Merged upstream patches:
  alt-owl-chown
- Removed obsolete patches:
  rh-CLOCK_REALTIME
  rh-df_spacedir
  rh-mem
  rh-utmp
- Added RH patches:
  rh-afs
  rh-langinfo
  rh-allow_old_options
  rh-alt-ls-stat
- Use tweaked help2man from this package for manpage generation.
- Do not build and package rm-static.

* Tue Jun 03 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt3
- Fixed file descriptor leakage in du (Jim Meyering).
- Build statically linked version of the GNU rm program
  and package it into rm-static subpackage.

* Fri May 02 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt2
- Regenerated manpages with help2man-1.29-alt2.
- Ported %%pre script to new uninstall_info.

* Sun Apr 06 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt1
- Updated to 5.0

* Mon Mar 31 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.12-alt1
- Updated to 4.5.12

* Thu Mar 20 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.11-alt1
- Updated to 4.5.11

* Fri Mar 14 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.10-alt1
- Updated to 4.5.10

* Wed Mar 05 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.9-alt1
- Updated to 4.5.9

* Sat Feb 22 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.8-alt1
- Updated to 4.5.8

* Mon Feb 10 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.7-alt1
- Updated to 4.5.7
- Updated patches:
  + alt-texinfo

* Thu Feb 06 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.6-alt1
- Updated to 4.5.6
- Merged upstream patches:
  + alt-who_xmalloc_fix
- Updated patches:
  + alt-texinfo

* Tue Feb 04 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.5-alt1
- Updated to 4.5.5
- Merged upstream patches:
  + alt-xalloc
  + alt-xgetcwd
  + alt-canonicalize
  + alt-readlink
  + alt-owl-rh-ls_restore_color
- New patches:
  + alt-xalloc
- Updated patches:
  + alt-mksock
  + alt-without-hostname-su-uptime

* Tue Feb 04 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt3
- who: fixed memory allocation arithmetic (#0002149).

* Sun Dec 01 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt2
- Removed automake patch (no longer needed with automake >= 1.7).
- Minor code cleanups (xalloc and xgetcwd).
- Added canonicalize_file_name implementation to libfetish;
  affects non-glibc platforms.
- Turned dir and vdir into symlinks to ls (#0001635).
- Updated dircolors.
- Removed obsolete (merged) patches:
  sh-utils-2.0-rh-rfc822
- Removed obsolete (not applied) patches:
  fileutils-4.0.38-alt-cp_deref_always
  fileutils-4.1-alt-cp_force_ignore
- Rediffed patches:
  rh-df_spacedir
  rh-install_strip
  rh-owl-alt-ls_dumbterm
  rh-CLOCK_REALTIME
  alt-owl-chown
- Corrected description.

* Thu Oct 31 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt1
- Updated to 4.5.3
- Our "ln --target-dir" fix merged upstream.

* Sun Oct 13 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.2-alt2
- Minor specfile tweaks.
- Updated buildrequires.

* Tue Oct 08 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.2-alt1
- Updated to 4.5.2
- Disabled cp_deref_always patch.
- Enabled tests by default.
- Fixed "ln --target-dir" (#0001369).

* Thu Sep 26 2002 Stanislav Ievlev <inger@altlinux.ru> 4.5.1-alt2
- Ressurected Conflicts.

* Tue Sep 17 2002 Stanislav Ievlev <inger@altlinux.ru> 4.5.1-alt1
- Inital build for ALT. This package is the union of the
  fileutils, sh-utils, and textutils packages.
- Review patches:
  + dropped "rh-stoneage" patch;
  + adopted readlink and mksock patches;
  + disabled "force interactive" patch.
